#! /usr/bin/python
import xml.sax
import string

#                           _____________
# inheritance  module name  | classname  |
#           |_____________|
class myxml(xml.sax.handler.ContentHandler):
    """
         A simple XML parser SAX.
         for RSS parsing.
    """
    def processingInstruction(self,*x):
        #print "yea."+str(x)
        pass

    def characters(self,text):
        #print "chars."

        prev_space=False
        temp_str=""
        
        for i in text:
            if((i==' ' and prev_space==True) or i=='\t' or i=='\r' or i=='\n'):
                prev_space=True
                continue
            else:
                if(i==' '):
                    prev_space=True
                else:
                    prev_space=False
                temp_str=temp_str + i
            
        text=temp_str;
        if(len(text) < 2):#ignore 1 letter strings.
            return
        
        if(self.char_print_flag==True):
            if(text[0]=='\n' or text[0]=='\r'):
                return                        
            #print "data sent"
            self.print_text+=text
        return
    
    def __init__(self):    #Inherit the good.
        #print "Creating Self"
        #print "Im born again"
        import time; #needed by start_document
        self.asctime=time.asctime;
        del time


        #for statistics.
        self.chap=0;
        self.sec=0;
        
        self.char_print_flag=False;
        self.print_text=""
        return

    def setDocumentLocator(self,*locator):
        #print "Locater set doc"
        return


    def setDocumentHandler(self,locator):
        #print "setDocumentHandler:"
        #print str(locator);
        return

    def startDocument(self):
        #print "startingDocument"
        print "<!-- GtkBook status report -->"
        print "<HTML>"
        print "<HEAD>"
        print "<TITLE>GtkBook Table of Contents , as on:"+self.asctime()+"</TITLE>"
        print "</HEAD>"
        print "<BODY BGCOLOR=\"white\" text=\"black\">"
        print "<TABLE ALIGN=\"CENTER\" WIDTH=\"50%\">"
        return

    def endDocument(self):
         #print "endingDocument"                  
         print "</TABLE>"
         print "<HR>"
         print "</BODY>"
         print "</HTML>"
         print "<!-- generated by Python with SAX -->"
         return

    def startPrefixMapping(self,prefix,inp):
        #print "prefixMapping"
        return

    def startElement(self,name,attrs):
        #print "startElement:",name
        self.char_print_flag=True;         
        if name == "Book":
            pass
        elif name == "Title":
            print "<TR BGCOLOR=\"#f0d0c0\"><TD>"+attrs.getValueByQName('name')+"</TD></TR>\n"
        elif name=="Toc":
            print "<TR BGCOLOR=\"#f0d0c0\"><TD>"+attrs.getValueByQName('name')+"</TD></TR>\n"            
        elif name == "Authors":
            print "<TR BGCOLOR=\"#f0d0c0\"><TD>"+ name+""+attrs.getValueByQName('name')+"</TD></TR>\n"
        elif name == "Preface":
            print "<TR BGCOLOR=\"#f0d0c0\"><TD>"+ name+""+attrs.getValueByQName('name')+"</TD></TR>\n"
        elif name=="Copyrights":
            print "<TR BGCOLOR=\"#f0d0c0\"><TD>"+ name+""+attrs.getValueByQName('name')+"</TD></TR>\n"
        elif name=="Acknowledgements":
            print "<TR BGCOLOR=\"#f0d0c0\"><TD>"+ name+""+attrs.getValueByQName('name')+"</TD></TR>\n"            
        elif name=="Appendix":
            print "<TR BGCOLOR=\"#f0d0c0\"><TD><FONT FACE=\"ITALIC\" COLOR=\"f08040\">"+attrs.getValueByQName('name')\
                  +"</FONT></TD></TR>\n<TR><TD>\n"
        elif name=="Glossary":
            print "<TR BGCOLOR=\"#f0d0c0\"><TD>"+name+""+attrs.getValueByQName('name')+"</TD></TR>\n"
        elif name=="Credits":
            print "<TR BGCOLOR=\"#f0d0c0\"><TD>"+name+""+attrs.getValueByQName('name')+"</TD></TR>\n"
        elif name=="Index":
            print "<TR BGCOLOR=\"#f0d0c0\"><TD>"+name+""+attrs.getValueByQName('name')+"</TD></TR>\n"
        elif name=="CHAP":
            self.chap=self.chap+1
            self.sec=0
            print "<TR BGCOLOR=\"#80f040\"><TD><FONT FACE=\"SANS\" COLOR=\"#0000ff\">Chapter"\
                  + str(self.chap)+"</FONT>&nbsp; &nbsp; &nbsp; &nbsp;"+attrs.getValueByQName('name')+"</TD></TR>\n"
        elif name=="SEC":
            self.sec=self.sec+1;
            self.print_text=self.print_text+"<TR><TD><FONT FACE=\"SANS\" COLOR=\"#8090f0\">SECTION: "\
                             +str(self.chap)+"."+str(self.sec)+"</FONT></TD></TR>\n<TR BGCOLOR=\"#ffeefc\"><TD>"
        return

    def endElement(self,name):
        #print "endElement:",name
        if(name=="SEC"):
            print "</TD></TR>\n"
        self.char_print_flag=False
        if(len(self.print_text)>0):
            print self.print_text
            self.print_text=""
        if( name=="Appendix"):
            print "</TD></TR>\n"
        return

if __name__ == "__main__":
    #create a new content handler.
    #start parsing the rss file.
    mxl=myxml()
    import sys;
    if(len(sys.argv) < 2):
        print "Usage: contents.py contents.xml"
        sys.exit(-1)
    #mxl=xml.sax.handler.ContentHandler()
    xml.sax.parse(sys.argv[1],mxl)


#DTD.
#Book
#\
#Title
#\name
#Toc
#\name
#Authors
#\name
#Preface
#\name
#Copyrights
#\name
#CHAP
#\name
##SEC
##/SEC
#/CHAP
#Appendix
#\name
#/Appendix
#Glossaray
#\name
#Credits
#\name
#Index
#\name
#/Book

#Thats All Folks!
# @      @  [Courtsey bugs bunny!]
#  \_||_/
#  (____)
