#! /usr/bin/python
import xml.sax
import string

#                           _____________
# inheritance  module name  | classname  |
#           |_____________|
class myxml(xml.sax.handler.ContentHandler):
    """
         A simple XML parser SAX.
         for RSS parsing.
    """
    def processingInstruction(self,*x):
        #print "yea."+str(x)
        pass

    def characters(self,text):
        #print "chars."

        prev_space=False
        temp_str=""
        
        for i in text:
            if((i==' ' and prev_space==True) or i=='\t' or i=='\r' or i=='\n'):
                prev_space=True
                continue
            else:
                if(i==' '):
                    prev_space=True
                else:
                    prev_space=False
                temp_str=temp_str + i
            
        text=temp_str;
        if(len(text) < 2):#ignore 1 letter strings.
            return
        
        if(self.char_print_flag==True):
            if(text[0]=='\n' or text[0]=='\r'):
                return                        
            #print "data sent"
            self.print_text+=text
        return
    
    def __init__(self):    #Inherit the good.
        #print "Creating Self"
        #print "Im born again"
        import time; #needed by start_document
        self.asctime=time.asctime;
        del time


        #for statistics.
        self.total=0
        
        self.m=0
        self.i=0
        self.o=0;#others
        
        self.m_widgets=""
        self.i_widgets=""
        self.o_widgets=""

        
        self.char_print_flag=False;
        self.print_text=""
        return

    def setDocumentLocator(self,*locator):
        #print "Locater set doc"
        return


    def setDocumentHandler(self,locator):
        #print "setDocumentHandler:"
        #print str(locator);
        return

    def startDocument(self):
        #print "startingDocument"
        print "<!-- GtkBook status report -->"
        print "<HTML>"
        print "<HEAD>"
        print "<TITLE>GtkBook Status report, as on:"+self.asctime()+"</TITLE>"
        print "</HEAD>"
        print "<BODY BGCOLOR=\"white\" text=\"black\">" 
        print "<H1><FONT COLOR=\"BLUE\"><I><CENTER>GtkBook Status Report</CENTER></I></FONT></CAPTION>"
        print "<TABLE ALIGN=\"CENTER\" WIDTH=\"50%\">"
        return

    def endDocument(self):
         #print "endingDocument"                  
         print "</TABLE>"

         print "<HR>"

         print "<TABLE ALIGN=\"CENTER\" WIDTH=\"50%\">"
         print "<CAPTION>Total Widgets: "+str(self.total)+" </CAPTION>"
         print "<TR BGCOLOR=\"#FEFAFE\"><TD> <FONT FACE=\"SANS\">Ishan Chattopadyaya's widgets</FONT> TOTAL "\
               +str(self.i)+"</TD></TR>"
         
         for tok in self.i_widgets.split(":"):
             print "<TR BGCOLOR=\"#C0DACA\"><TD>"+tok+"</TD></TR>"
         print "<TR BGCOLOR=\"#ABACAA\"><TD></TD></TR>"

             
         print "<TR BGCOLOR=\"#FEFAFE\"><TD> <FONT FACE=\"SANS\">Muthiah Annamalai's widgets</FONT> TOTAL "\
               +str(self.m)+"</TD></TR>"
         
         for tok in self.m_widgets.split(":"):
             print "<TR BGCOLOR=\"#CODACA\"><TD>"+tok+"</TD></TR>"
         print "<TR BGCOLOR=\"#ABACAA\"><TD></TD></TR>"
         

         print "<TR BGCOLOR=\"#FEFAFE\"><TD> <FONT FACE=\"SANS\">Orphan Widgets</FONT> TOTAL "\
               +str(self.o)+"</TD></TR>"
         
         for tok in self.o_widgets.split(":"):
             print "<TR BGCOLOR=\"#CODACA\"><TD>"+tok+"</TD></TR>"
         print "<TR BGCOLOR=\"#ABACAA\"><TD></TD></TR>"

         
         
         print "</BODY>"
         print "</HTML>"
         print "<!-- generated by Python with SAX -->"
         return

    def startPrefixMapping(self,prefix,inp):
        #print "prefixMapping"
        return

    def startElement(self,name,attrs):
        #print "startElement:",name
        self.char_print_flag=True;
        if name == "BOOK":
            #print "Book:"
            pass
        elif name=="WIDGET":
            self.total=self.total+1
            
            self.char_print_flag=False;
            self.print_text="<TR BGCOLOR=\"#ffccee\"><TD>"+self.print_text+" \
            <FONT FACE=\"SANS\" COLOR=\"NAVY\">"+attrs.getValueByQName('NAME')+"</FONT></TD></TR>\n"
            
            if(attrs.getValueByQName('STATUS')!="incomplete"):
                self.print_text+="<TR BGCOLOR=\"#DADECE\"><TD><I>STATUS</I>:<FONT FACE=\"SANS\" COLOR=\"RED\">"\
                                  +attrs.getValueByQName('STATUS')+"</FONT></TD></TR>\n";
                self.print_text+="<TR><TD><I>DATE</I>: "+attrs.getValueByQName('DATE')+"</TD></TR>\n"
                self.print_text+="<TR BGCOLOR=\"#effedc\"><TD>"
                if(attrs.getValueByQName("AUTHOR")=="M"):
                    self.print_text+="<FONT FACE=\"SANS\" COLOR=\"GREEN\">AUTHOR</FONT>: \
                    Muthiah Annamalai"
                    self.m=self.m+1
                    self.m_widgets+=":"+attrs.getValueByQName("NAME")
                elif (attrs.getValueByQName("AUTHOR")=="I"):
                    self.print_text+="<FONT FACE=\"SANS\"  COLOR=\"GREEN\">AUTHOR</FONT>: \
                    Ishan Chattopadyaya"
                    self.i=self.i+1
                    self.i_widgets+=":"+attrs.getValueByQName("NAME")
                    
                else:
                    self.print_text+="<FONT FACE=\"SANS\" COLOR=\"GREEN\">AUTHOR</FONT>:"+\
                                      attrs.getValueByQName("AUTHOR")
                    self.o=self.o+1
                    self.o_widgets+=":"+attrs.getValueByQName("NAME")
                    
                self.print_text+="</TD></TR>\n"
            else:
                self.print_text+="<TR BGCOLOR=\"#FEEFEE\"><TD><I>STATUS</I>: [PENDING]\
                <FONT FACE=\"SANS\" COLOR=\"MAROON\">incomplete</FONT></TD></TR>\n";
                self.o=self.o+1
                self.o_widgets+=":"+attrs.getValueByQName("NAME")

        return

    def endElement(self,name):
        #print "endElement:",name
        self.char_print_flag=False
        if(len(self.print_text)>0):
            print self.print_text
            self.print_text=""
        return


if __name__ == "__main__":
    #create a new content handler.
    #start parsing the rss file.
    mxl=myxml()
    import sys;
    if(len(sys.argv) < 2):
        print "Usage: widget.py widget.xml"
        sys.exit(-1)
    #mxl=xml.sax.handler.ContentHandler()
    xml.sax.parse(sys.argv[1],mxl)


#DTD.
#book
#widget
# \
#  name, author, date,status
# /
#widget
#book

#Thats All Folks!
# @      @  [Courtsey bugs bunny!]
#  \_||_/
#  (____)
